;--------------------------------------------------------
;	GoForth Version 1.5				;
;	Roger Stone  3-10-2008				;
;--------------------------------------------------------
#include \goasm\include\gowindows.inc
#include \goasm\include\all_api.inc
#include \goasm\include\kernel32.inc

;----------------------------------------------------------------
data

;WM_HAVE_FOCUS	equ WM_USER+100

;BLUE		equ 0B00000h
;GREEN		equ 0008000h
;MAGENTA		equ 0A000B0h

ClassName 	db "WindClass",0
AppName  	db "Radix Manipulator",0
EditClass 	db "EDIT",0
RichDLL		db "Riched20.dll",0
RichClass	db "RichEdit20A",0

ALIGN 4
hInstance	DD 0
hWndEditBot	dd 0
ThreadID	DD 0
hTextFlag	DD 0

hRichDLL    HMODULE     ?
hRWnd       DD        ?

OldWndProcTop	dd 0
OldWndProcBot	dd 0

;ScnColor	dd GREEN

KeyBdBuff	db 80h dup (0) 		; Buffer for keyboard use
TextBuffNextPtr	dd 0			; Pointer to next char in Text Buffer
TextBuffEndPtr	dd 0			; Pointer to end of Text Buffer
TextBuff	db 80h dup (0) 		; Text input buffer for Forth

charrng		CHARRANGE  
charfmt		CHARFORMAT 

FMessg1		db	0Dh,0Ah,0Dh,0Ah,'                  MULTI RADIX '
		db	0Dh,0Ah,0Dh,0Ah,'Written in Forth32 v1.5        Assembled by GoAsm',13,10,13,10
		db	0Dh,0Ah,'      Roger Stone            20 October 2008 ',0Dh,0Ah,0Dh,0Ah,0
FMessg2		db	'Enter calculations in Reverse Polish Notation',13,10
		DB	'= displays the result',13,10,13,10
		db	'Example:-       1 2 + =       3 ok',13,10,13,10
		db	'Operators are + - * / AND OR XOR',13,10,13,10
		db	'HEX, DEC, OCT, and BIN change the radix.',13,10,13,10
		db	'Any other radix may be set with the form N RADIX',13,10,13,10
		db	'CHAR? will list the character set in use for the current radix',13,10,13,10
		db	'All entries are case sensitive. ',13,10,13,10,0
FMessg3		db	'?', "  ",13,10,0
FMessg4		db	' ok',0Dh,0Ah,0 
FMessg5		db	0Dh,0Ah,0
FMessg6		db	' Divide by Zero error ', 0Dh, 0Ah, 0
FMessg7		db	' not unique ' ,0
FMessg8		db	1
FMessg9		db	1
FMessg10	db	1
FMessg11	db	1

align	4
CharCount	DD	0
CHOUT		DD	0
TextBPtr	DD	0
TextBEndPtr	DD	0
Text_Buff	DD	80 dup 0
TextOBPtr	DD	0
TextOutBuff	DD	80 dup 0
h_at:		DD	offset FreeSpace ;, 00000h, 00000h, offset isx -8
lfastart:	DD	offset charq -12
;Snort_at	DD	offset idstack
;Rnort_at	DD	offset irstack		; <<<<<<<<<<<<<<<<<check out
base_at	 	DD	0000Ah

ALIGN 4
;------------------------------------------------
;	Headerless Asm Code
;------------------------------------------------
exit:		DD	t_exit
h:		DD	t_h
base:		DD	t_base
lit:		DD	t_lit
obranch:	DD	t_obranch
branch:		DD	t_branch
f_docol:	DD	docol
for:		DD	t_for
next:		DD	t_next
oneplus:	DD	t_oneplus
oneminus:	DD	t_oneminus
negate:		DD	t_negate
swap:		DD	t_swap
dupe:		DD	t_dupe
over:		DD	t_over
rot:		DD	t_rot
drop:		DD	t_drop
plus_under:	DD	t_plus_under
zero_equals:  	DD	t_zero_equals
notx:		DD	t_notx
zero_lt:	DD	t_zero_lt
less_than:	DD	t_less_than
great_than:	DD	t_great_than
equals:		DD	t_equals
u_less:		DD	t_u_less
store:		DD	t_store
@:		DD	t_@
c@:		DD	t_c@
pushx:		DD	t_pushx
popx:		DD	t_popx
i:		DD	t_i
r@:		DD	t_r@
absx:		DD	t_absx
min:		DD	t_min
max:		DD	t_max
execute:	DD	t_execute
emit:		DD	t_emit
c@_plus:	DD	t_c@_plus
setstacks:	DD	t_setstacks
count:		DD	docol
t_count:	DD	c@_plus, exit	
typex:		DD	t_typex
type$:		DD	t_type$	
space:		DD	t_space 	
expect:		DD	t_expect
wordx:		DD	t_wordx	
find:		DD	t_find
digit:		DD	t_digit
;------------------------------------------------
;	Asm Code
;------------------------------------------------
		DD	0000h
null$:		db	0,0,0,0h
;------------------------------------------------
		DD	null$ -4
		db	1, '0'		,0,0
zero:		DD	t_zero
;------------------------------------------------
		DD	zero -8
		db	1, '1'		,0,0
one:		DD	t_one
;------------------------------------------------
		DD	one -8
		db	1, '+'		,0,0
plus:		DD	t_plus
;------------------------------------------------
		DD	plus -8
		db	1, '-'		,0,0
minus:		DD	t_minus
;------------------------------------------------
		DD	minus -8
		db	1, '*'		,0,0
mult:		DD	t_mult
;------------------------------------------------
		DD	mult -8
		db	1, '/'		,0,0
divx:		DD	t_divx
;------------------------------------------------
		DD	divx -8
		db	2, 'OR'		,0
orx:		DD	t_orx
;------------------------------------------------
		DD	orx -8
		db	3, 'XOR'
xorx:		DD	t_xorx
;-----------------------------------------------
		DD	xorx -8
		db	3, 'AND'
andx:		DD	t_andx
;------------------------------------------------
;	Forth Code
;-----------------------------------------------
		DD	andx -8
		db	3, 'DEC'
decimal:	DD	docol, lit, 0Ah, base, store, exit	
;-----------------------------------------------
		DD	decimal -8
		db	3, 'HEX'
hex:		DD	docol, lit, 0010h, base, store, exit
;------------------------------------------------
hold:		DD	docol, swap, pushx, swap, oneplus, popx, exit
;-----------------------------------------------
numb_bkt:	DD	docol, drop, for, numb2 
numb1:		DD	emit 
numb2:		DD	next, numb1, exit
;-----------------------------------------------
dot:		DD	docol, dupe, pushx, absx, zero, swap
		DD	digit, popx ;sign
		DD	zero_lt, obranch, sign1, lit, 02Dh, hold
sign1:		DD	space, numb_bkt
		DD	space, exit	
;-----------------------------------------------
		DD	dot -8
		db	6, 'SETCOL'	,0
setcol:		DD	t_setcol
;-----------------------------------------------
		DD	setcol -12
		db	5, 'RADIX'	,0,0
radixx:		DD	docol, base, store, exit	
;-----------------------------------------------
		DD	radixx -12
		db	3, 'OCT'	
oct:		DD	docol, lit, 8, base, store, exit	
;-----------------------------------------------
		DD	oct -8
		db	3, 'BIN'	
bin:		DD	docol, lit, 2, base, store, exit	
;-----------------------------------------------
		DD	bin -8
		db	6, 'RADIX?'	,0
radixq:		DD	docol, base, @, decimal, dot, lit,45h, base, store, lit, 35177h, dot, base, store,exit 	
;-----------------------------------------------
		DD	radixq -12
		db	5, 'CHAR?'	,0,0
charq:		DD	docol, base, @, dupe, for, charq2
charq1:		DD	dupe, i, minus, one, minus, dot
charq2:		DD	next, charq1 ,exit	
;-----------------------------------------------
here:		DD	t_here	
;-----------------------------------------------
dot_qt:		DD	t_dot_qt	;docol
		DD	popx, dupe, type$, count, plus, pushx, exit	
;-----------------------------------------------
m_digit:	DD	docol, lit, 030h, minus, dupe, lit, 09h, great_than, obranch, mdigit1
		DD	lit, 07h, minus, dupe, lit, 0Ah, less_than, orx
mdigit1:	DD	dupe, base, @, u_less, obranch, abortq2, exit			; good route
abortq2:	DD	here, type$, space, dot_qt, FMessg3, quit			; bad route
;-----------------------------------------------
number:		DD	docol, count, base, @, pushx, over, c@, lit, 02Dh, equals, dupe, pushx, obranch, bksnum1
		DD	oneminus, one, plus_under
bksnum1:	DD	over, c@, lit, 024h, equals, obranch, bksnum2, hex, oneminus, one, plus_under
bksnum2:	DD	over, c@, lit, 027h, equals, obranch, bksnum3, drop, oneplus, c@, branch, bksnum6
bksnum3:	DD	zero, rot, rot, for, bksnum5
bksnum4:	DD	dupe, c@, m_digit
		DD	rot, base, @, mult, plus, swap, oneplus
bksnum5:	DD	next, bksnum4, drop
bksnum6:	DD	popx, obranch, bksnum7, negate
bksnum7:	DD	popx, base, store, exit	
;-----------------------------------------------
interpret:	DD	docol
interp9:	DD	expect, notx, obranch, interp1, branch, interp9
interp1:	DD	lit, 04h, lit, 020h
		DD	wordx, obranch, interp3, drop, lit,04, find ;swap, find
		DD	obranch, interp2, number, branch, interp1
interp2:	DD	execute, branch, interp1	
interp3:	DD	exit
;-----------------------------------------------
quit:		DD	docol, setstacks
bkquit1:	DD	interpret, dot_qt, FMessg4
		DD	branch, bkquit1	
;----------------------------------------------- 
		DD	words -12
		db	5, 'RESET'	,0,0
reset:		DD	f_docol 
		DD	decimal, lit, 13, base, store
		DD	dot_qt, FMessg2
		DD	quit	
;-------------------
ALIGN 4
starter:	DD	reset

;----------------------------------------------------------------
ALIGN 4
FreeSpace	DD  8000h dup ?
irstack		DD  1000h dup ?
idstack		DD  1000h dup ?
;----------------------------------------------------------------
;	Start of Code
;----------------------------------------------------------------
code
start:
	invoke GetModuleHandle, NULL
	mov    [hInstance],eax
	invoke WinMain, [hInstance],NULL,NULL, SW_SHOWDEFAULT
	invoke ExitProcess,eax
;----------------------------------------------------------------

WinMain FRAME hInst,hPrevInst,CmdLine,CmdShow
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hwnd

	mov D[wc.cbSize],SIZEOF WNDCLASSEX
	mov D[wc.style], CS_HREDRAW or CS_VREDRAW
	mov D[wc.lpfnWndProc], OFFSET WndProc
	mov D[wc.cbClsExtra],NULL
	mov D[wc.cbWndExtra],NULL
	push [hInst]
	pop [wc.hInstance]
	mov D[wc.hbrBackground], COLOR_ACTIVEBORDER+1
	mov D[wc.lpszMenuName],NULL
	mov D[wc.lpszClassName],OFFSET ClassName
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov [wc.hIcon],eax
	mov [wc.hIconSm],eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov [wc.hCursor],eax
	invoke RegisterClassEx, addr wc
	invoke CreateWindowEx,WS_EX_CLIENTEDGE,ADDR ClassName,ADDR AppName,\
           WS_OVERLAPPED+WS_VISIBLE+WS_CAPTION+WS_SYSMENU+WS_MINIMIZEBOX+WS_MAXIMIZEBOX,\
           CW_USEDEFAULT,CW_USEDEFAULT,680,485,NULL,NULL,[hInst],NULL
	mov [hwnd],eax

	invoke SendMessage, [hWndEditBot], EM_SETMARGINS, EC_LEFTMARGIN+EC_RIGHTMARGIN, 00C000Ch

			;Retrieve a message from the thread message queue
x1:             invoke GetMessage, ADDR msg,NULL,0,0
		cmp eax,-1
		jz >x2				;exit if error 
		test eax,eax			;EAX=0 if WM_QUIT
		jz >x2
                invoke TranslateMessage, ADDR msg
                invoke DispatchMessage, ADDR msg
		jmp x1
x2:		mov eax,[msg.wParam]
	ret
WinMain endf
;----------------------------------------------------------------
WndProc FRAME hWnd, uMsg, wParam, lParam

      LOCAL hdc

	mov eax,[uMsg]
	;---------------------
	cmp eax,WM_CREATE
	jnz >>w1

	;----------<  Create a RichEdit window and subclass it  >--------

        	; Must load this dll is Loaded 
		invoke LoadLibrary, ADDR RichDLL
		mov [hRichDLL],eax

		invoke CreateWindowEx,WS_EX_CLIENTEDGE,ADDR RichClass,NULL,\			;WS_EX_CLIENTEDGE
     	           WS_CHILD+WS_VISIBLE+ES_MULTILINE+ES_AUTOVSCROLL,\	;+WS_BORDER,\ES_AUTOHSCROLL+
        	   20,20,630,410,[hWnd],NULL,[hInstance],NULL
		mov [hWndEditBot],eax
		invoke SetFocus,eax
			; Make it a Subclass
		invoke SetWindowLong,[hWndEditBot],GWL_WNDPROC,addr EditWndProcBot
		mov [OldWndProcBot],eax


		; limit text to 4MB
		invoke SendMessage, [hWndEditBot],EM_EXLIMITTEXT,NULL,0400000h

		; set a nicer font
		invoke GetStockObject, SYSTEM_FIXED_FONT   ;could also use: ,   DEFAULT_GUI_FONT    OEM_FIXED_FONT
		invoke SendMessage, [hWndEditBot],WM_SETFONT,eax,TRUE

	;--------------------<  Start App thread  >----------------------

		mov  eax,OFFSET ThreadProc
		invoke CreateThread, NULL, NULL, OFFSET ThreadProc, NULL,\
		     NORMAL_PRIORITY_CLASS, ADDR ThreadID
		invoke CloseHandle,eax			; will not need handle
			; Create event object to communicate with thread
		invoke CreateEvent,NULL,TRUE,FALSE,NULL
		mov [hTextFlag],eax
		jmp >w4
	;---------------------
w1:	cmp eax,WM_DESTROY
	jnz >w2
		invoke PostQuitMessage,NULL
		jmp >w4
	;---------------------
w2:	
w3:		invoke DefWindowProc,[hWnd],[uMsg],[wParam],[lParam]		
		ret
	;---------------------
w4:	xor eax,eax
	ret
WndProc endf
;----------------------------------------------------------------
EditWndProcBot FRAME hEdit,uMsg,wParam,lParam

	mov eax,[uMsg]
	;---------------------
	cmp eax,WM_CHAR
	jnz >b1
		mov eax,[wParam]				; wParam is key character


		cmp al,VK_RETURN
		jz >> b2					; dont want ret in buffer but must let old proc have it
		cmp al,VK_BACK
		jnz >c1
		dec B[KeyBdBuff]				; do the backspace here, 
		jmp >>b2					; no need for it to go into buffer
		;-----
			; put chars into buffer
c1:		movzx ecx, B[KeyBdBuff]				; Get count from start of buffer
        	inc ecx
        	mov [KeyBdBuff],cl				; save it
        	add ecx, offset KeyBdBuff			; point to end
        	mov [ecx],eax					; move character
		jmp >>b2					; now send chars to original procedure
	;---------------------
b1:	cmp eax,WM_KEYDOWN
	jnz >b2
	    mov eax,[wParam]
	    cmp al,VK_RETURN					; Only do when return key
	    jnz >b2						; send rest to original procedure

	;---------------< copy to thread buffer >------------------------

		push edi
		push esi
		mov esi, addr KeyBdBuff
		mov edi, addr TextBuff			; First byte is count
		movzx ecx, B[KeyBdBuff]
		inc esi					; don't include count byte
		rep movsb
		mov B[edi],20h				; space to mark end of last word
		mov [TextBuffEndPtr],edi
		mov eax,0
		mov edi,eax				; add zeros to end
		pop esi
		pop edi
			; prepare for next time
		mov D[CHOUT],'    '		
	invoke [SendMessage], [hWndEditBot], EM_REPLACESEL, 0, offset CHOUT 
	        mov D[KeyBdBuff],0				; reset count for next time
		invoke SetEvent,[hTextFlag]			; Tell thread its there
	xor eax,eax						; don't need original proccedure
	ret
	;---------------------
b2:	invoke CallWindowProc,[OldWndProcBot],[hEdit],[uMsg],[wParam],[lParam]
	ret
endf
;----------------------------------------------------------------

ThreadProc FRAME lParam	; Parse Text from keboard

		;------------< Startup Message >------------

		invoke RichAppend, offset FMessg1, 0FFh

	
		mov ebp,addr irstack	
		mov eax,addr starter
		mov esi,eax
		lodsd
		mov ecx,[eax]
		mov ecx,[ecx]
		jmp ecx	
;------------------------------------------------
;	Main Forth Asm Code 			;
;------------------------------------------------

t_expect:	push ebx
		invoke WaitForSingleObject,[hTextFlag],3E8h
		sub ebx,ebx
		cmp eax, WAIT_TIMEOUT
		je >t1
		dec ebx
t1:		push ebx
		invoke ResetEvent, [hTextFlag]	
		pop ebx

		mov eax,Addr TextBuff-1		;Initialise Pointer
		mov [TextBuffNextPtr],eax
		lodsd
		mov ecx,[eax]
		jmp ecx
;------------------------------------------------
t_wordx:	mov edx,ebx 			; save delimiter charcter ( " " , "(" , or ' " ' )
		mov ebx,[TextBuffNextPtr]
			; discard spaces
w1:		inc ebx
		cmp ebx,[TextBuffEndPtr] ;edx
		jg >w6				; End of string means no more words
		movzx eax,B[ebx]		; get char
		cmp eax, edx 			; is it delimiter
		jz <w1				; loop while space 
		cmp eax,0dh
		jz >w6				; return means no more words
		dec ebx				; Will fetch char again
			; move string
		mov edi,[h_at]			; address next Free Space
		inc edi				; allow room for count
		sub ecx,ecx			; Set count to 0
w2:		inc ebx
		cmp ebx,[TextBuffEndPtr] ;edx
		jg >w6				; End of string means no more words
		inc ecx				; count chars
		movzx eax,B[ebx]		; get char
		cmp eax, edx 			; is it delimiter at end
		jz >w3				; word found if it is
		cmp eax,0dh
		jz >w3				; word found if return
		stosb				; char to freespace
		jmp <w2				; loop for more
		;-------- word found -------
w3:		dec cl				; Adjust for space
		dec ebx
		mov [TextBuffNextPtr],ebx
		mov ebx, [h_at]			; address next free space also required on stack
		mov [ebx],cl
		push ebx			; save start address of word 
		sub ebx,ebx
		dec ebx				; set flag = ON for not found word found
		lodsd
		mov ecx,[eax]
		jmp ecx
		;------ word not found ------
w6:		push edi			; dest address to stack
		sub ebx,ebx			; set flag = OFF for found no words
		lodsd
		mov ecx,[eax]
		jmp ecx
;------------------------------------------------
t_find:		mov edx,esi
		mov edi,offset lfastart 
		pop ebx		
		mov ebx, [h_at]			; pops free space pntr (loose context adjustor )
		sub eax,eax
		mov al,[ebx]			; get word count
		inc eax
		push edi			; save initial link address
f1:		pop edi				; recover old LFA
		mov edi,[edi]			; get new LFA
		test edi,edi			; zero is end ie address at 'NULL'
		jne >f2				; not end so go and compare more words
		push ebx			; save start address of word 
		sub ebx,ebx
		dec ebx				; set flag = ON for not found
		mov esi,edx
		lodsd
		mov ecx,[eax]
		jmp ecx
		;------
f2:		push edi			; save LFApointer
		add edi,4			; pass name pointer and point to string count
		mov esi,ebx			; compare with string now in free space
		mov ecx,eax			; get word size of word in free space
	   repe cmpsb				; look for word
		jne f1				; jump if not this time
		pop eax				; drop pointer
		cmp b[edi],0D6h		; test for magic char not valid
		jne >f3
		inc edi			; go this if magic char
		mov edi,[edi]
f3:		dec edi				; align to DD
		or edi,03
		inc edi
		push edi			; dest address to stack
		sub ebx,ebx			; set flag = OFF for found
		mov esi,edx
		lodsd
		mov ecx,[eax]
		jmp ecx
;------------------------------------------------
t_setstacks:	push ebx
		mov esp,offset idstack
		mov ebp,offset irstack
		lodsd
		mov ecx,[eax]
		jmp ecx
;------------------------------------------------
;	Word Code Section			;
;------------------------------------------------
t_lit:		push ebx
		lodsd
		mov ebx,eax
		lodsd
		mov ecx,[eax]
		jmp ecx
;-----------------------------------------------
t_obranch:	lodsd
		test ebx,ebx
		jne >b1
		mov esi,eax
b1:		pop ebx
		lodsd
		mov ecx,[eax]
		jmp ecx
;------------------------------------------------
t_branch:	mov esi,[esi]
		lodsd
		mov ecx,[eax]
		jmp ecx
;------------------------------------------------
docol:		xchg ebp,esp
		push esi
		xchg ebp,esp
		add eax,04
		mov esi,eax
		lodsd
		mov ecx,[eax]
		jmp ecx	
;-----------------------------------------------
t_for:		xchg ebp,esp	
		push ebx
		xchg ebp,esp	
		pop ebx
		mov esi,[esi]
		lodsd
		mov ecx,[eax]
		jmp ecx
;-----------------------------------------------
t_next:		sub w[ebp],1
		jc >n1
		mov esi,[esi]
		lodsd
		mov ecx,[eax]
		jmp ecx
		;-----------------
n1:		add ebp,4
		add esi,4
		lodsd
		mov ecx,[eax]
		jmp ecx
;-----------------------------------------------
t_null$:	xchg ebp,esp
		pop esi
		xchg ebp,esp
nxt:		lodsd
		mov ecx,[eax]
		jmp ecx
;-----------------------------------------------
t_exit:		xchg ebp,esp
		pop esi
		xchg ebp,esp
		lodsd
		mov ecx,[eax]
		jmp ecx
;-----------------------------------------------
t_h:		push ebx
		mov ebx,offset h_at
		lodsd
		mov ecx,[eax]
		jmp ecx
;-----------------------------------------------
t_base:		push ebx
		mov ebx,offset base_at
		lodsd
		mov ecx,[eax]
		jmp ecx
;-----------------------------------------------
t_zero:		push ebx
		mov ebx,0
		lodsd
		mov ecx,[eax]
		jmp ecx
;-----------------------------------------------
t_one:		push ebx
		mov ebx,1
		lodsd
		mov ecx,[eax]
		jmp ecx
;-----------------------------------------------
t_two:		push ebx
		mov ebx,2
		lodsd
		mov ecx,[eax]
		jmp ecx
;------------------------------------------------
t_plus:		pop eax
		add ebx,eax
		lodsd
		mov ecx,[eax]
		jmp ecx
;-----------------------------------------------
t_minus:	mov eax,ebx
		pop ebx
		sub ebx,eax
		lodsd
		mov ecx,[eax]
		jmp ecx
;-----------------------------------------------
t_mult:		pop eax
		imul ebx
		mov ebx,eax
		lodsd
		mov ecx,[eax]
		jmp ecx
;-----------------------------------------------
t_divx:		pop eax
		cdq
t1:	or ebx,ebx
	jz >t2
		idiv ebx
		mov ebx,eax
		lodsd
		mov ecx,[eax]
		jmp ecx
t2: 		invoke RichAppend, offset FMessg6,0FFh
		lodsd
		mov ecx,[eax]
		jmp ecx
;-----------------------------------------------
t_oneplus:	inc ebx
		lodsd
		mov ecx,[eax]
		jmp ecx
;-----------------------------------------------
t_oneminus:	dec ebx
		lodsd
		mov ecx,[eax]
		jmp ecx
;-----------------------------------------------
t_negate:	neg ebx
		lodsd
		mov ecx,[eax]
		jmp ecx
;-----------------------------------------------
t_swap:		pop eax
		push ebx
		mov ebx,eax
		lodsd
		mov ecx,[eax]
		jmp ecx
;-----------------------------------------------
t_nip:		pop eax
		lodsd
		mov ecx,[eax]
		jmp ecx
;-----------------------------------------------
t_over:		pop eax
		push eax
		push ebx
		mov ebx,eax
		lodsd
		mov ecx,[eax]
		jmp ecx
;-----------------------------------------------
t_dupe:		push ebx
		lodsd
		mov ecx,[eax]
		jmp ecx
;-----------------------------------------------
t_rot:		pop eax
		pop edx
		push eax
		push ebx
		mov ebx,edx
		lodsd
		mov ecx,[eax]
		jmp ecx
;-----------------------------------------------
t_drop:		pop ebx
		lodsd
		mov ecx,[eax]
		jmp ecx
;-----------------------------------------------
t_plus_under:	pop edx
		pop eax
		add ebx,eax
		push ebx
		mov ebx,edx
		lodsd
		mov ecx,[eax]
		jmp ecx
;-----------------------------------------------
t_zero_equals:	sub ebx,1
		sbb ebx,ebx
		lodsd
		mov ecx,[eax]
		jmp ecx
;-----------------------------------------------
t_notx:		sub ebx,1
		sbb ebx,ebx
		lodsd
		mov ecx,[eax]
		jmp ecx	
;-----------------------------------------------
t_zero_lt:	shl ebx,1
		sbb ebx,ebx
		lodsd
		mov ecx,[eax]
		jmp ecx
;-----------------------------------------------
t_orx:		pop eax
		or ebx,eax
		lodsd
		mov ecx,[eax]
		jmp ecx
;-----------------------------------------------
t_xorx:		pop eax
		xor ebx,eax
		lodsd
		mov ecx,[eax]
		jmp ecx
;-----------------------------------------------
t_andx:		pop eax
		and ebx,eax
		lodsd
		mov ecx,[eax]
		jmp ecx
;-----------------------------------------------
t_less_than:	pop eax
		sub eax,ebx
		mov ebx,0
		jge >l1
		dec ebx
l1:		lodsd
		mov ecx,[eax]
		jmp ecx
;-----------------------------------------------
t_great_than:	pop eax
		sub ebx,eax
		mov ebx,0
		jge >g1
		dec ebx
g1:		lodsd
		mov ecx,[eax]
		jmp ecx
;-----------------------------------------------
t_equals:	pop eax
		sub eax,ebx
		sub eax,1
		sbb ebx,ebx
		lodsd
		mov ecx,[eax]
		jmp ecx
;-----------------------------------------------
t_u_less:	pop eax
		sub eax,ebx
		sbb ebx,ebx
		lodsd
		mov ecx,[eax]
		jmp ecx
;-----------------------------------------------
t_u_mod:	pop eax
		sub edx,edx
t1:		or ebx,ebx
		jz >t2
		div ebx
		push edx
		mov ebx,eax
		lodsd
		mov ecx,[eax]
		jmp ecx
		;-------
t2: 		invoke RichAppend, offset FMessg6,0FFh
		lodsd
		mov ecx,[eax]
		jmp ecx
;-----------------------------------------------
t_store:	pop eax
		mov [ebx],eax
		pop ebx
		lodsd
		mov ecx,[eax]
		jmp ecx
;-----------------------------------------------
t_@:		mov ebx,[ebx]
		lodsd
		mov ecx,[eax]
		jmp ecx
;-----------------------------------------------
t_c@:		mov al,[ebx]
		sub ebx,ebx
		mov bl,al
		lodsd
		mov ecx,[eax]
		jmp ecx
;-----------------------------------------------
t_pushx:	xchg ebp,esp
		push ebx
		xchg ebp,esp
		pop ebx
		lodsd
		mov ecx,[eax]
		jmp ecx
;-----------------------------------------------
t_i:		push ebx
		mov ebx,[ebp]
		lodsd
		mov ecx,[eax]
		jmp ecx
;-----------------------------------------------
t_popx:		push ebx
		xchg ebp,esp
		pop ebx
		xchg ebp,esp
		lodsd
		mov ecx,[eax]
		jmp ecx
;-----------------------------------------------
t_r@:		push ebx
		mov ebx,[ebp]
		lodsd
		mov ecx,[eax]
		jmp ecx
;-----------------------------------------------
t_absx:		test ebx,ebx
		jns >a1
		neg ebx
a1:		lodsd
		mov ecx,[eax]
		jmp ecx
;-----------------------------------------------
t_min:		pop eax
		cmp ebx,eax
		jle >m1
		mov ebx,eax
m1:		lodsd
		mov ecx,[eax]
		jmp ecx
;-----------------------------------------------
t_max:		pop eax
		cmp ebx,eax
		jge >m2
		mov ebx,eax
m2:		lodsd
		mov ecx,[eax]
		jmp ecx
;-----------------------------------------------
t_execute:	mov D[CharCount], 0	; reset line count
		mov eax,ebx
		pop ebx
		mov ecx,[eax]
		jmp ecx	
;-----------------------------------------------
t_digit:	push ebx
		pop eax
		sub edx,edx
		mov ebx,[base_at]
		or ebx,ebx
		jz >t2
		div ebx			; divide by radix
		push eax
		mov ebx,edx	
		jmp >t1
		;-------
t2: 		invoke RichAppend, offset FMessg6,0FFh
t1:		cmp ebx, 09h		; turn number into ASCII code
		mov eax,0
		jle >t3
		dec eax
t3:		and eax, 07h		; works for base > 16
		add ebx,eax
		add ebx, 030h
		pop ecx
		pop eax
		push ebx
		inc eax
		push eax
		mov ebx,ecx
		push ebx
		sub ebx,1
		sbb ebx,ebx
		test ebx,ebx
		pop ebx	
		je t_digit
b1:		lodsd
		mov ecx,[eax]
		jmp ecx
;-----------------------------------------------
t_hold:		pop ecx		; spare copy
		pop eax
		push ebx
		inc eax
		push eax
		mov ebx,ecx
		lodsd
		mov ecx,[eax]
		jmp ecx	
;-----------------------------------------------
t_space:	push ebx
		mov ebx, 020h		
t_emit:		mov [CHOUT],ebx
	invoke [SendMessage], [hWndEditBot], EM_REPLACESEL, 0, offset CHOUT ;send
		pop ebx
		lodsd
		mov ecx,[eax]
		jmp ecx
;-----------------------------------------------
t_c@_plus:	mov al,[ebx]
		inc ebx
		push ebx
		sub ebx,ebx
		mov bl,al
		lodsd
		mov ecx,[eax]
		jmp ecx
;------------------------------------------------
t_dot_qt:	lodsd
		invoke [SendMessage], [hWndEditBot], EM_REPLACESEL, 0, eax ; eax = offset of text string
		lodsd
		mov ecx,[eax]
		jmp ecx
;------------------------------------------------
t_type$:
		mov al,[ebx]
		inc ebx
		push ebx
		sub ebx,ebx
		mov bl,al
t_typex:	add [CharCount], ebx
		cmp D[CharCount], 02Ah
		jc >n2
		push ebx
		mov [CHOUT],eax		
	invoke [SendMessage], [hWndEditBot], EM_REPLACESEL, 0, offset FMessg5
		pop ebx
		mov D[CharCount], 0
n2:		mov ecx, ebx	
		pop ebx
		jcxz >n1
typex1:		movzx eax, B[ebx]
		inc ebx
		push ebx
		sub ebx,ebx
		;mov bl,al
		push ecx
		mov [CHOUT],eax		
	invoke [SendMessage], [hWndEditBot], EM_REPLACESEL, 0, offset CHOUT 
		pop ecx
		pop ebx
		dec ecx
		jg typex1
n1:		pop ebx
		lodsd
		mov ecx,[eax]
		jmp ecx	
;-----------------------------------------------
t_here:		push ebx
		mov ebx,[h_at]
		lodsd
		mov ecx,[eax]
		jmp ecx
;-----------------------------------------------
t_setcol:	mov [charfmt.crTextColor],ebx
		invoke SendMessage, [hWndEditBot], EM_SETCHARFORMAT,SCF_SELECTION, addr charfmt
		lodsd
		mov ecx,[eax]
		jmp ecx
;-----------------------------------------------
align 4

	invoke [SendMessage], [hWndEditBot], EM_REPLACESEL, 0, offset CHOUT ;send

	ret
;------------------------------------------------
endf

;----------------------------------------------------------------

RichAppend FRAME pBuff,col
    mov eax,-1
    mov [charrng.cpMax],eax
    mov [charrng.cpMin],eax
    mov D[charfmt.cbSize],SIZEOF CHARFORMAT
    mov D[charfmt.dwMask],CFM_COLOR
    mov eax,[col]
    mov [charfmt.crTextColor],eax
    invoke SendMessage, [hWndEditBot],EM_EXSETSEL,NULL,ADDR charrng
    invoke SendMessage, [hWndEditBot],EM_SETCHARFORMAT,SCF_SELECTION,ADDR charfmt
    invoke SendMessage, [hWndEditBot],EM_REPLACESEL,FALSE,[pBuff]
    invoke SendMessage, [hWndEditBot],EM_SCROLLCARET,NULL,NULL ;scroll the text into view
    ret
RichAppend ENDF
;----------------------------------------------------------------

